<template>
<div class="wrapper wrapper-content animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>List Of User</h5>
            <div class="ibox-tools">
                <a class="btn btn-primary btn-xs" @click="modal_show()">
                    Add User
                </a>
                <a @click="load_user()">
                    <i class="fa fa-refresh"></i>
                </a>
          </div>
        </div>
        <!-- /.ibox-titel -->
        
        <div class="ibox-content">
            <!-- Search and filter form -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="pull-left form-inline">
                        <label>Show 
                            <input type="number" v-model="show_row" class="form-control input-sm" 
                                    style="width:60px;" min="1" max="1000">
                        </label>


                        <label>&nbsp;&nbsp;Limit
                            <input type="number" v-model="limit" class="form-control input-sm" 
                                    style="width:70px;" min="1" max="1000">
                        </label>
                    </div>

                    <div class="pull-right form-inline">
                        <label>Search:
                            <input v-model="search_key" class="form-control input-sm">
                        </label>&nbsp;
                    </div>
                </div>
            </div>
            <!-- /.row -->
          
            <div class="row" v-if="users.total">
                <div class="col-lg-12">
                    <div>
                        <div>
                            <p class="pull-left" style="margin-top: 7px;">
                                Showing  {{ users.from }} to  {{ users.to }}  of  {{ users.total }} entries.
                            </p>
                        </div>
                        <div class="table_pagination">
                            <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                        
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !users.prev_page_url }" 
                                    @click=" gen_uri( users.prev_page_url )"
                                >
                                    <span>Prev</span>
                                </a>  
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !users.first_page_url }" 
                                    @click=" gen_uri( users.first_page_url )">
                                    <span>First</span>
                                </a>
                                <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !users.last_page_url }" 
                                    @click=" gen_uri(users.last_page_url)">
                                <span>Last</span>
                                </a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !users.next_page_url }" 
                                    @click=" gen_uri( users.next_page_url )"
                                >
                                <span>Next</span>
                                </a>
                            </div>
                        </div>        
                    </div>
                </div>
            </div>
            <!-- /.row -->

            <!-- Table -->
            <div class="table-responsive project-list">
                <table class="table table-stripped">
                    <thead>
                        <tr>
                            <th class="text-center">#</th>
                            <th>Name</th>
                            <th>Email</th>
                            <th>ACTIVE</th>
                            <th>&nbsp;</th>
                        </tr>
                    </thead>
                    <tbody v-if="loading">
                        <tr>
                            <td colspan="5">
                                <spinner></spinner>
                            </td>
                        </tr>
                    </tbody>
                    <tbody  v-else-if="users.data.length">
                        <user-table v-for="(user, row) in users.data" :key="user.id" 
                                    :user="user" :row="row"
                        >
                        </user-table>
                    </tbody>
                    <tbody v-else>
                        <tr>
                            <td colspan="7" class="text-center">
                                No Result!
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <!-- /.table-responsive -->
        </div>
        <!-- /.ibox-content -->
      </div>
      <!-- /.ibox float-e-margins -->
    </div>
    <!-- /.col-lg-12 -->
  </div>
  <!-- /.row -->

  <user-modal v-on:save="user_store" v-bind:modal="modal">
  </user-modal>
</div>  
<!-- /.wrapper wrapper-content animated fadeInRight -->
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../other/Spinner.vue'
import appService from '../../app.service.js'

export default {
    components: {
        'user-modal': Modal,
        'user-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            users: [],
            modal: { 
                pause_save: false,
                errors: '',
                data: {
                    name: '',
                    email: '',
                    is_active: true
                }
            },
        }
    },
    methods: {
        load_user () {
            this.loading = true
            let uri = this.uri
            axios.get(uri).then(response => {
                this.users = response.data.users
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'user',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }
            this.uri = appService.crud.generate_url( query ) 
            this.$router.push( this.uri )
        },
        modal_show() {
            this.modal.errors = ''
            this.modal.data = {
                name: '',
                email: '',
                is_active: '1',
            }

            $('#user_modal').modal('show');
        },
        user_store( data ) {
            this.modal.pause_save = true
            axios.post('/user',  data ).then(response => {
                if(response.data.errors) {
                    this.modal.errors = response.data.errors
                }else{
                    $('#user_modal').modal('hide')
                    toastr.success( response.data.msg, 'Saved!' )
                    toastr.info( response.data.password , 'New Password!' )
                    this.load_user()
                }
                
                this.modal.pause_save = false
            })
        }
    },  
    watch: {
        '$route' (to, from) {
            this.load_user()
        },
        show_row: function () {
            this.gen_uri()
        },
        limit: function () {
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
            this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_user()
    }
}
</script>